﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace CS_W32_terminal_hex
{
    public partial class Form1 : Form
    {
        SerialPort serial;
        int baudRate;

        #region ctor
        public Form1()
        {
            InitializeComponent();
            this.Closing += new CancelEventHandler(Form1_Closing);

            serial = new SerialPort();
            // 8N1
            serial.Parity = Parity.None;
            serial.StopBits = StopBits.One;
            serial.DataBits = 8;
            serial.Handshake = Handshake.None;
            serial.ReadTimeout = 1000;
            serial.WriteTimeout = 1000;
            serial.DataReceived += new SerialDataReceivedEventHandler(serial_DataReceived);

            toolStripStatusLabel1.Text = "Loading";
            string[] temp = SerialPort.GetPortNames();
            if (temp.Length != 0)
            {
                comboBox1.Tag = temp;
                for (int i = 0; i < temp.Length; i++)
                {
                    comboBox1.Items.Add(temp[i]);
                }
                comboBox1.SelectedIndex = 0;
                butt_connect.Enabled = true;
            }

            for (int i = 0; i < 4; i++)
            {
                RadioButton a = new RadioButton();
                a.Bounds = new Rectangle(3, i * 23, panel1.ClientSize.Width - 6, 23);
                switch (i)
                {
                    case 0:
                        //
                        a.Text = "4800";
                        a.Tag = 4800;
                        a.Checked = true;
                        this.baudRate = 4800;
                        break;

                    case 1:
                        //
                        a.Text = "9600";
                        a.Tag = 9600;
                        break;

                    case 2:
                        //
                        a.Text = "19200";
                        a.Tag = 19200;
                        break;

                    case 3:
                        //
                        a.Text = "57600";
                        a.Tag = 57600;
                        break;

                    default:
                        break;
                }

                a.Click += new EventHandler(rb_Click);
                a.Parent = panel1;
            }

            toolStripStatusLabel1.Text = "Disconnected";

            this.Resize += new EventHandler(Form1_Resize);
        }

        #endregion


        #region formEvents

        void Form1_Resize(object sender, EventArgs e)
        {
            textBox1.Width = this.Width - 40;
            textBox2.Width = this.Width - 40;
            buttonSend.Left = this.Width - (340-237);
        }

        void rb_Click(object sender, EventArgs e)
        {
            this.baudRate = (int)(((RadioButton)sender).Tag);
        }

        void serial_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            try
            {
                if (this.serial.BytesToRead > 0)
                {
                    byte[] tmp = new byte[this.serial.BytesToRead];
                    this.serial.Read(tmp, 0, tmp.Length);
                    StringBuilder builder = new StringBuilder();
                    for (int i = 0; i < tmp.Length; i++)
                    {
                        builder.Append((char)tmp[i]);
                    }
                    if (textBox1.InvokeRequired)
                    {
                        Invoke(new EventHandler(delegate { textBox1.Text = "Received data: " + builder.ToString() + "\r\n" + textBox1.Text; }));
                    }
                    else
                    {
                        textBox1.Text = "Received data: " + builder.ToString() + "\r\n" + textBox1.Text;
                    }

                    if (this.checkLoop.InvokeRequired)
                    {
                        Invoke(new EventHandler(delegate
                        {
                            if (this.checkLoop.Checked == true)
                            {
                                this.serial.Write(tmp, 0, tmp.Length);
                            }
                        }));
                    }
                    else
                    {
                        if (this.checkLoop.Checked == true)
                        {
                            this.serial.Write(tmp, 0, tmp.Length);
                        }
                    }
                }
            }
            catch (Exception)
            {

                throw;
            }

        }

        void Form1_Closing(object sender, CancelEventArgs e)
        {
            if (this.serial != null && this.serial.IsOpen)
            {
                this.serial.Close();
            }
        }
        #endregion

        private void butt_connect_Click(object sender, EventArgs e)
        {
            try
            {
                if (this.serial != null)
                {
                    if (!this.serial.IsOpen)
                    {
                        // port neotevren
                        this.serial.PortName = ((string[])this.comboBox1.Tag)[this.comboBox1.SelectedIndex];
                        this.serial.BaudRate = this.baudRate;
                        this.serial.Open();
                        this.panel1.Enabled = false;
                        this.comboBox1.Enabled = false;
                        this.textBox1.Text = "Port " + this.serial.PortName + " opened\r\n" + this.textBox1.Text;
                        this.toolStripStatusLabel1.Text = "Connected";
                        this.butt_connect.Text = "Disconnect";
                    }
                    else
                    {
                        //port otevren, zavrit
                        this.toolStripStatusLabel1.Text = "Closing port";
                        this.statusStrip1.Update();
                        this.serial.DiscardInBuffer();
                        this.serial.Close();
                        this.panel1.Enabled = true;
                        this.comboBox1.Enabled = true;
                        this.textBox1.Text = "Port " + this.serial.PortName + " closed\r\n" + this.textBox1.Text;
                        this.toolStripStatusLabel1.Text = "Disconnected";
                        this.butt_connect.Text = "Connect";
                    }
                }
            }
            catch (Exception)
            {

                throw;
            }
        }

        private void buttonSend_Click(object sender, EventArgs e)
        {
            //
            char[] tmp_ch = textBox2.Text.ToCharArray();
            byte[] tmp_b = new byte[tmp_ch.Length];
            for (int i = 0; i < tmp_ch.Length; i++)
			{
                if (tmp_ch[i] != 'ě' && tmp_ch[i] != 'š' && tmp_ch[i] != 'č' && tmp_ch[i] != 'ř' && tmp_ch[i] != 'ž' && tmp_ch[i] != 'ú' && tmp_ch[i] != 'ů' && tmp_ch[i] != 'Ě' && tmp_ch[i] != 'Š' && tmp_ch[i] != 'Č' && tmp_ch[i] != 'Ř' && tmp_ch[i] != 'Ž' && tmp_ch[i] != 'Ú' && tmp_ch[i] != 'Ů' && tmp_ch[i] != 'ť' && tmp_ch[i] != 'Ť' && tmp_ch[i] != 'ň' && tmp_ch[i] != 'Ň' && tmp_ch[i] != 'ď' && tmp_ch[i] != 'Ď')
                {
                    tmp_b[i] = (byte)tmp_ch[i];
                }
                else
                {
                    switch (tmp_ch[i])
                    {
                            /*á - 225 
                            é - 233 
                            ě - 236 
                            š - 154 
                            č - 232 
                            ř - 248 
                            ž - 158 
                            ý - 253 
                            ů - 249 
                            ú - 250 
                            ó - 243 
                            í - 237 
                            ď - 239
                            ť - 
                            ň - 242*/
                        case 'ě':
                            tmp_b[i] = 236;
                            break;
                        case 'š':
                            tmp_b[i] = 154;
                            break;
                        case 'č':
                            tmp_b[i] = 232;
                            break;
                        case 'ř':
                            tmp_b[i] = 248;
                            break;
                        case 'ž':
                            tmp_b[i] = 158;
                            break;
                        case 'Ě':
                            tmp_b[i] = 204;
                            break;
                        case 'Š':
                            tmp_b[i] = 138;
                            break;
                        case 'Č':
                            tmp_b[i] = 200;
                            break;
                        case 'Ř':
                            tmp_b[i] = 216;
                            break;
                        case 'Ž':
                            tmp_b[i] = 142;
                            break;
                        case 'ú':
                            tmp_b[i] = 250;
                            break;
                        case 'ů':
                            tmp_b[i] = 249;
                            break;
                        case 'Ú':
                            tmp_b[i] = 218;
                            break;
                        case 'Ů':
                            tmp_b[i] = 217;
                            break;
                        case 'ď':
                            tmp_b[i] = 239;
                            break;
                        case 'Ď':
                            tmp_b[i] = 207;
                            break;
                        case 'ť':
                            tmp_b[i] = 157;
                            break;
                        case 'Ť':
                            tmp_b[i] = 141;
                            break;
                        case 'ň':
                            tmp_b[i] = 242;
                            break;
                        case 'Ň':
                            tmp_b[i] = 210;
                            break;
                        default:
                            tmp_b[i] = (byte)tmp_ch[i];
                            break;
                    }
                }
			}
            byte[] vystup = new byte[tmp_b.Length];
            int indexTmp = 0, indexVystup = 0;
            byte cislo;
            StringBuilder strB = new StringBuilder();
            try
            {
                for (indexTmp = 0; indexTmp < tmp_b.Length; indexTmp++)
                {
                    //
                    if (tmp_b[indexTmp] == '$')
                    {
                        // HEX
                        strB.Remove(0, strB.Length);
                        strB.Append((char)tmp_b[indexTmp + 1]);
                        strB.Append((char)tmp_b[indexTmp + 2]);
                        cislo = Byte.Parse(strB.ToString(), System.Globalization.NumberStyles.AllowHexSpecifier);
                        vystup[indexVystup++] = cislo;
                        indexTmp += 2;
                    }
                    else if (tmp_b[indexTmp] == '#')
                    {
                        // DEC
                        strB.Remove(0, strB.Length);
                        strB.Append((char)tmp_b[indexTmp + 1]);
                        strB.Append((char)tmp_b[indexTmp + 2]);
                        strB.Append((char)tmp_b[indexTmp + 3]);
                        cislo = Byte.Parse(strB.ToString());
                        vystup[indexVystup++] = cislo;
                        indexTmp += 3;
                    }
                    else
                    {
                        vystup[indexVystup++] = tmp_b[indexTmp];
                    }
                }
            }
            catch (Exception)
            {

                if (tmp_b.Length - indexTmp > 11)
                {
                    MessageBox.Show("Parse error near \"" + this.textBox2.Text.Substring(indexTmp, 10) + "\"");
                }
                else
                {
                    MessageBox.Show("Parse error near \"" + this.textBox2.Text.Substring(indexTmp) + "\"");
                }
            }


            try
            {
                if (serial.IsOpen)
                {
                    serial.Write(vystup, 0, indexVystup);

                    strB.Remove(0, strB.Length);
                    for (int i = 0; i < indexVystup; i++)
                    {
                        if (vystup[i] != 0)
                        {
                            strB.Append((char)vystup[i]);
                        }
                        else
                        {
                            strB.Append("\\0");
                        }
                    }
                    this.textBox1.Text = "Sent: \"" + strB.ToString() + "\"\r\n" + this.textBox1.Text;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Cybka pri odesilani: " + ex.Message);
            }
        }

    }
}